]> git.pld-linux.org Git - packages/mysql.git/blob - mysql.init
- release 2
[packages/mysql.git] / mysql.init
1 #!/bin/sh
2 #
3 # mysql         A very fast and reliable SQL database engine
4 #
5 # chkconfig:    2345 84 25
6 #
7 # description:  A very fast and reliable SQL database engine.
8 #
9 # $Id$
10
11 # Source function library
12 . /etc/rc.d/init.d/functions
13
14 # Get network config
15 . /etc/sysconfig/network
16
17 # Get service config
18 if [ -f /etc/sysconfig/mysql ]; then
19         . /etc/sysconfig/mysql
20 else
21         nls "Error: %s not found" /etc/sysconfig/mysql
22         nls "%s can't be run." MySQL
23         exit 1
24 fi
25
26 if [ -n "$MYSQL_DB_CLUSTERS" ]; then
27         nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
28 fi
29
30 if [ -f /etc/mysql/clusters.conf ]; then
31         MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/{print $2}' /etc/mysql/clusters.conf)
32         if [ -z "$MYSQL_DB_CLUSTERS"  ]; then
33                 nls "Warning: there are no configured clusters."
34         fi
35
36 else
37         nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
38         if [ -z "$MYSQL_DB_CLUSTERS"  ]; then
39                 nls "Warning: there are no configured clusters."
40                 nls "Using default cluster /var/lib/mysql (compatibility mode)"
41                 MYSQL_DB_CLUSTERS=/var/lib/mysql
42         fi
43 fi
44
45
46 # Check that networking is up
47 if is_yes "${NETWORKING}"; then
48         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
49                 msg_network_down MySQL
50                 exit 1
51         fi
52 else
53         exit 0
54 fi
55
56 action="$1"
57
58 # any db cluster as command line argument?
59 if [ $# -gt 1 ]; then
60         shift
61         # perform action for specified clusters only
62         for a in "$@"; do
63                 # try auto resolving from /etc/mysql/clusters.conf
64                 if [[ "$a" != /* ]]; then
65                         m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66                         if [ -z "$m" ]; then
67                                 echo >&2 "Cluster name '$a' did not match anything!"
68                                 exit 1
69                         fi
70                         if [ $(echo "$m" | wc -l) -gt 1 ]; then
71                                 echo >&2 "Cluster name '$a' ambiguous:" $m
72                                 exit 1
73                         fi
74                         a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75                 fi
76                 DB_CLUSTERS="$DB_CLUSTERS $a"
77         done
78 else
79         DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80 fi
81
82 # global error log, if mysqld.conf hasn't migrated to log-error style
83 MYSQL_ERRLOG=/var/log/mysql/mysqld.log
84 MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86 #
87 # Useful functions.
88 #
89
90 #
91 # check for mysql status
92 #
93 # arguments:
94 # $1 - db cluster
95 # $2 - start|stop
96 #
97 # sets variables:
98 # MYSQL_STATUS = starting | running | not running | died
99 # MYSQL_PID    = pid of mysqld process
100 #
101 mysqlstatus() {
102         clusterdir="$1"
103         mode="$2"
104         
105         mysqlgetconfig "$clusterdir"
106
107         MYSQL_STATUS="not running"
108         MYSQL_PID="unknown"
109         MYSQL_PIDFILE_PID=""
110         MYSQL_GREP_PID=""
111
112         if [ -f "$MYSQL_PIDFILE" ]; then
113                 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114         fi
115         
116         if [ -n "$MYSQL_PIDFILE_PID" ]; then
117                 MYSQL_PID=$MYSQL_PIDFILE_PID
118                 if [ ! -d "/proc/$MYSQL_PID" ]; then
119                         MYSQL_STATUS="died"
120                         return
121                 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122                         MYSQL_STATUS="running"
123                         return
124                 fi
125         fi
126
127         if [ "$mode" = "start" ]; then
128                 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129                 if [ -n "$MYSQL_GREP_PID" ]; then
130                         MYSQL_PID=$MYSQL_GREP_PID
131                         if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132                                 if [ -f "$MYSQL_PIDFILE" ]; then
133                                         MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134                                 fi
135                                 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136                                         MYSQL_PID=$MYSQL_PIDFILE_PID
137                                         MYSQL_STATUS="running"
138                                         return
139                                 else
140                                         MYSQL_STATUS="starting"
141                                         return
142                                 fi
143                         fi
144                 fi
145         fi
146
147         # else default, "not running"
148 }
149
150 # get mysql configuration in variables
151 # MYSQL_CONFIG MYSQL_CLUSTER_DIR
152 # MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153 #
154 # arguments
155 # $1 - db cluster
156
157 mysqlgetconfig() {
158         local clusterdir="$1" config_file
159
160         # emulate old behaviour if only one cluster specified
161         if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
162                 MYSQL_RA_COMPAT=yes
163                 config_file=/etc/mysqld.conf
164         else
165                 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
166                 if [[ $config = /* ]]; then
167                         config_file="$config"
168                 elif [ -f "/etc/mysql/$config" ]; then
169                         config_file="/etc/mysql/$config"
170                 else
171                         config_file="$clusterdir/mysqld.conf"
172                 fi
173         fi
174
175         MYSQL_CLUSTER_DIR="$clusterdir"
176
177         if [ -z "$config_file" ]; then
178                 nls "Error: Can't find config file for %s cluster" "$clusterdir"
179                 exit 6
180         else
181                 MYSQL_CONFIG="$config_file"
182         fi
183
184         if [ ! -f "$config_file" ]; then
185                 nls "Error: config file %s not found" "$config_file"
186                 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
187                 exit 6
188         fi
189
190         # reset to initial state
191         MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
192
193         eval `awk -F= '
194         # skip comments and empty lines
195         /^[;#]|^ *$/ { next }
196
197         /^[ \t]*\[.*\][ \t]*$/ {
198                 match($0, /\[.*\]/);
199                 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
200                 next;
201         }
202
203         # trim spaces
204         {
205                 gsub(/^[\t ]*|[\t ]*$/, "", $1);
206                 gsub(/^[\t ]*|[\t ]*$/, "", $2);
207         }
208
209         section == "mysqld" {
210                 if ($1 == "datadir") {
211                         printf("MYSQL_DATA_DIR=%s;", $2);
212                 } else if ($1 == "user") {
213                         printf("MYSQL_USER=%s;", $2);
214                 } else if ($1 == "pid-file") {
215                         printf("MYSQL_PIDFILE=%s;", $2);
216                 } else if ($1 == "socket") {
217                         printf("MYSQL_SOCKET=%s;", $2);
218                 } else if ($1 == "port") {
219                         printf("MYSQL_PORT=%s;", $2);
220                 } else if ($1 == "bind-address") {
221                         printf("MYSQL_BIND_ADDRESS=%s;", $2);
222                 } else if ($1 == "skip-networking") {
223                         printf("MYSQL_SKIP_NETWORKING=1;");
224                 } else if ($1 == "log-error") {
225                         printf("MYSQL_LOG_ERROR=%s;", $2);
226                 }
227         }
228         ' $config_file`
229
230         # error log not defined in config file. add one
231         if [ -z "$MYSQL_LOG_ERROR" ]; then
232                 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
233         else
234                 # unset, so mysqld would use value from config itself
235                 unset MYSQL_LOG_ERROR
236         fi
237
238         if is_yes "$MYSQL_RA_COMPAT"; then
239                 MYSQL_DATA_DIR_SUB=""
240         else
241                 MYSQL_DATA_DIR_SUB="/mysqldb"
242         fi
243
244         if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
245                 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
246                 nls " MySQL can't be run."
247                 exit 6
248         fi
249
250         if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
251                 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
252                 nls " MySQL can't be run."
253                 exit 6
254         fi
255
256         if [ -z "$MYSQL_USER" ]; then
257                 echo "$(nls 'MySQL user not configured properly')"'!' >&2
258                 nls "Edit %s and configure it." "$config_file" >&2
259                 exit 6
260         fi
261 }
262
263 # start mysql
264 mysqlstart() {
265         local clusterdir="$1"
266         mysqlgetconfig "$clusterdir"
267         if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
268                 nls "MySQL cluster %s not initialized." "$clusterdir"
269                 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
270                 exit 6
271         fi
272
273         msg_starting "MySQL $clusterdir"; busy
274         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
275         rm -f "$MYSQL_PIDFILE"
276
277
278         TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
279                 /usr/bin/setsid /usr/sbin/mysqld \
280                         --defaults-file=$MYSQL_CONFIG \
281                         --datadir=$MYSQL_DATA_DIR \
282                         --pid-file=$MYSQL_PIDFILE \
283                         ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
284                         $MYSQL_OPTIONS &
285         pid=$!
286
287         sleep 0.1
288         mysqlstatus "$clusterdir" start
289         # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
290         if [ "$MYSQL_STATUS" = "starting" ]; then
291                 echo ""
292                 show "Waiting for MySQL to start"
293                 busy
294
295                 # while the pid is running, mysql is starting up
296                 # if the pidfile was created, it started up successfully
297                 # if either case fails we break and report status
298                 while true; do
299                         [ -d /proc/$pid ] || break
300                         [ -f "$MYSQL_PIDFILE" ] && break
301                         sleep 0.2
302                 done
303         fi
304
305         mysqlstatus "$clusterdir" start
306         if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
307                 ok
308         elif [ "$MYSQL_STATUS" = "died" ]; then
309                 RETVAL=1
310                 died
311         else
312                 RETVAL=1
313                 fail
314         fi
315 }
316
317 # stop mysql
318 mysqlstop() {
319         local clusterdir="$1"
320         mysqlstatus "$clusterdir" stop
321         msg_stopping "MySQL $clusterdir"
322         busy
323
324         # try graceful shutdown -- send shutdown command
325         # requires mysql_sysadmin user proper privs
326         /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
327         mysqlstatus "$clusterdir" stop
328
329         if [ "$MYSQL_PID" != "unknown" ]; then
330                 kill -TERM "$MYSQL_PID" 2> /dev/null
331                 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
332                         [ -d "/proc/$MYSQL_PID" ] || break
333                         sleep 0.1
334                 done
335         fi
336         
337         mysqlstatus "$clusterdir" stop
338         if [ "$MYSQL_STATUS" = "died" ]; then
339                 died
340         elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
341                 fail
342         else
343                 ok
344         fi
345 }
346
347 #
348 # check for running mysql instances; if any instance is running then
349 # create subsys lock file
350 #
351 mysqlsubsys() {
352         # check for every defined db cluster in sysconfig file
353         for mysqldir in $DB_CLUSTERS; do
354                 mysqlstatus "$mysqldir"
355                 if [ "$MYSQL_STATUS" = "running" ]; then
356                         touch /var/lock/subsys/mysql
357                         return
358                 fi
359         done
360         rm -f /var/lock/subsys/mysql
361 }
362
363 mysqlinit() {
364         local clusterdir="$1"
365
366         if [ -f /etc/mysqld.conf ]; then
367                 nls "Running in \`no cluster compat' mode: can't initialize database."
368                 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
369                 exit 1
370         fi
371
372         if [ -f "$clusterdir/mysqld.conf" ]; then
373                 mysqlgetconfig "$clusterdir"
374         else
375                 MYSQL_USER="mysql"
376                 MYSQL_CLUSTER_DIR="$clusterdir"
377                 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
378                 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
379                 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
380
381                 # this $MYSQL_CONFIG will be created later
382                 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
383         fi
384
385         show "Initializing cluster %s" "$clusterdir"; echo
386
387         # Check if not exist init database
388         if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
389                 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
390                 nls "before initializing database."
391                 nls "For now skipping cluster %s." "$clusterdir"
392                 return
393         fi
394
395         show "Installing MySQL system tables for $MYSQL_DATA_DIR"
396         busy
397         TMP=/tmp TMPDIR=/tmp
398
399         mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
400         # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
401         chown root:root "$MYSQL_CLUSTER_DIR"
402         chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
403         chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
404
405         if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
406             sed -e "
407                 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
408                 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
409                 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
410                 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
411                 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
412             chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
413             chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
414         fi
415
416         if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
417                 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
418             ln -s "$sock" /var/lib/mysql/mysql.sock
419         fi
420
421         cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
422                 CREATE DATABASE mysql;
423                 use mysql;
424                 $(cat /usr/share/mysql/mysql_system_tables.sql)
425                 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
426 EOF
427
428         ok=0
429         /usr/sbin/mysqld \
430                 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
431                 --bootstrap \
432                 --skip-grant-tables \
433                 --skip-innodb \
434                 --datadir=$MYSQL_DATA_DIR \
435                 --user=$MYSQL_USER \
436                 --slave-load-tmpdir=$MYSQL_DATA_DIR \
437                 --tmpdir=$MYSQL_DATA_DIR \
438                 --log-error=$MYSQL_ERRLOG \
439                 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
440         [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
441
442         if [ "$ok" = 1 ]; then
443                 rm -f $MYSQL_DATA_DIR/mysql-init.sql
444                 ok
445                 cat << END_OF_MSG
446
447 PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
448 This is done, after starting database, in the order shown,
449 with:
450
451 For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
452 echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
453
454 For 'mysql' user (ALL privileges, DB admin):
455 echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
456
457 NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
458 mysqladmin section. See the manual for more instructions.
459 (This user is used at logs rotation and server shutdown)
460
461 END_OF_MSG
462                 show "Filling help tables..."
463                 ok=0
464                 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
465                         /usr/sbin/mysqld \
466                         --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
467                         --bootstrap \
468                         --skip-grant-tables \
469                         --skip-innodb \
470                         --datadir=$MYSQL_DATA_DIR \
471                         --user=$MYSQL_USER \
472                         --slave-load-tmpdir=$MYSQL_DATA_DIR \
473                         --tmpdir=$MYSQL_DATA_DIR \
474                         --log-error=$MYSQL_ERRLOG \
475                         && ok=1
476                 if [ "$ok" = 1 ]; then
477                         ok
478                 else
479                         cat << END_OF_MSG
480
481 WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
482 The "HELP" command might not work properly.
483
484 END_OF_MSG
485                 fi
486         else
487                 fail
488                 cat << END_OF_MSG
489 Installation of grant tables FAILED!
490
491 The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
492
493 Examine the logs in /var/log/mysql for more information.  You can
494 also try to start the mysqld daemon with:
495
496 /usr/sbin/mysqld --skip-grant &
497
498 You can use the command line tool mysql to connect to the mysql
499 database and look at the grant tables:
500
501 shell> mysql -u mysql mysql
502 mysql> show tables
503
504 Try 'mysqld --help' if you have problems with paths. Setting on
505 logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
506 may be helpful. The latest information about MySQL is available on the
507 web at http://www.mysql.com/.
508
509 Please check PLD Linux ftp site for newer versions of this package.
510
511 Please consult the MySQL manual section: 'Problems running
512 mysql_install_db', and the manual section that describes problems on
513 your OS.  Another information source is the MySQL email archive.
514
515 END_OF_MSG
516                 exit 1
517         fi
518 }
519
520 #
521 # End of useful functions.
522 #
523
524 start() {
525         local mysqldir
526         for mysqldir in $DB_CLUSTERS; do
527                 mysqlstatus "$mysqldir" start
528                 if [ "$MYSQL_STATUS" = "running" ]; then
529                         msg_already_running "MySQL $mysqldir"
530                 else
531                         mysqlstart "$mysqldir"
532                 fi
533         done
534         mysqlsubsys
535 }
536
537 stop() {
538         local mysqldir
539         for mysqldir in $DB_CLUSTERS; do
540                 mysqlstatus "$mysqldir" stop
541                 if [ "$MYSQL_STATUS" = "not running" ]; then
542                         msg_not_running "MySQL $mysqldir"
543                 else
544                         mysqlstop "$mysqldir"
545                 fi
546         done
547         mysqlsubsys
548 }
549
550 condrestart() {
551         if [ ! -f /var/lock/subsys/mysql ]; then
552                 msg_not_running "MySQL"
553                 RETVAL=$1
554                 return
555         fi
556
557         stop
558         start
559 }
560
561 RETVAL=0
562 case "$action" in
563   start)
564         start
565         ;;
566   stop)
567         stop
568         ;;
569   restart)
570         stop
571         start
572         ;;
573   try-restart)
574         condrestart 0
575         ;;
576   force-reload)
577         condrestart 7
578         ;;
579   init)
580         for mysqldir in $DB_CLUSTERS; do
581                 mysqlinit "$mysqldir"
582         done
583         exit $?
584         ;;
585   flush-logs)
586         for mysqldir in $DB_CLUSTERS; do
587             mysqlgetconfig "$mysqldir"
588                 # just if mysqld is really running
589                 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
590                         /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
591                 fi
592         done
593         ;;
594   status)
595         for mysqldir in $DB_CLUSTERS; do
596                 mysqlstatus "$mysqldir"
597                 if [ "$MYSQL_STATUS" = "running" ]; then
598                         addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
599                         port=${MYSQL_PORT:-3306}
600                         socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
601                         pid=$MYSQL_PID
602                         nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
603                         [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
604                         nls "\tunix:%s\n" "$socket"
605                         pids="$pids/$MYSQL_PID/"
606                         progress "$MYSQL_STATUS"
607                 else
608                         show "MySQL cluster %s" "$mysqldir"
609                         progress "$MYSQL_STATUS" "$CFAIL"
610                 fi
611                 echo
612         done
613
614         for pid in $(/sbin/pidof mysqld); do
615                 if [[ $pids != */$pid/* ]]; then
616                         running="$running $pid"
617                 fi
618         done
619
620         if [ $# = 1 -a "$running" ]; then
621                 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
622                 # see if we can display their status
623                 for pid in $running; do
624                         datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
625                         datadir=${datadir#--datadir=} # strip --datadir
626                         mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
627                         mysqlstatus "$mysqldir"
628                         if [ "$MYSQL_STATUS" = "running" ]; then
629                                 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
630                                 port=${MYSQL_PORT:-3306}
631                                 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
632                                 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
633                                 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
634                                 nls "\tunix:%s\n" "$socket"
635                                 progress "$MYSQL_STATUS"
636                         else
637                                 show "MySQL cluster %s" "$mysqldir"
638                                 progress "$MYSQL_STATUS" "$CFAIL"
639                         fi
640                         echo
641                 done
642         fi
643         ;;
644   *)
645         msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
646         exit 3
647 esac
648
649 exit $RETVAL
This page took 0.069023 seconds and 3 git commands to generate.